#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include <ctype.h>
#include <math.h>
#include <shellapi.h>
#include <dos.h>
#include <fcntl.h>
#include <mem.h>
#include <new.h>
#include <setjmp.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>
#include <dir.h>
#include "defines.h"
#include "xy.h"
#include "xyz.h"
//#include "mesh.h"
/*-----*/
char*progname=PROGNAME;
typedef uns char byte;
HMENU mainmenu; HWND mwn=0; HINSTANCE Instance=0,PrevInstance=0;
short CmdShow=0; byte Nn=0,fileopen=0;
char tit[256],title[256],file[256]={0},File[256]={0},rootdir[256]; byte KEYS[256];
char name[256],posername[256]; FILE*MKM=0,*OBJ=0,*CR2=0;
OPENFILENAME ofn; byte Argc;
extern double BALLVERTS[114][3];
extern char BALLFACES[];
extern char BONDVERTS[];
extern char BONDFACES[];
extern char*ACTORBODY;
extern char ACTORROOT[];
extern char ACTORATOM1[],ACTORATOM2[],ACTORATOM3[];
extern char MATERIAL[];
/*-----*/
int readkey(char*keyname);
char strang[1024];
/*-----*/
int manipulate(char*key) {
char strang2[1024]; int  rv;
rv = readkey(key);
if(rv != 13) return rv;
strcpy(strang2,strang);
strcat(strang2,"\\Shell\\open\\command");
strang[0]= 0;
rv = readkey(strang2);
return rv;}
/*-----*/
int readkey(char * keyname){
if(keyname == NULL) {return 10;}
else {
	 HKEY  hkey = NULL;
	 DWORD dwType = REG_SZ;
	 unsigned long cbBufferSize = 1023;
	 if(RegOpenKeyEx(HKEY_CLASSES_ROOT,keyname,0,KEY_QUERY_VALUE,&hkey ) != ERROR_SUCCESS) return 11;
	 if(RegQueryValueEx(hkey,"",0,&dwType,strang,&cbBufferSize) != ERROR_SUCCESS) {RegCloseKey (hkey); return 12;}
	 RegCloseKey(hkey);}
return 13;}
/*-----*/
int GetFileName(HWND wn,char*file,char*initdir,char*t,char*f,int write) {int j;
//strcpy(file,tit);
ofn.lStructSize=sizeof(OPENFILENAME); ofn.hwndOwner=wn;
ofn.lpstrFilter=f; ofn.lpstrCustomFilter=0; ofn.nFilterIndex=0;
ofn.lpstrFile=file; ofn.nMaxFile=128;
ofn.lpstrFileTitle=tit; ofn.nMaxFileTitle=256;
ofn.lpstrInitialDir=initdir; ofn.lpstrTitle=t;
ofn.Flags=write?OFN_OVERWRITEPROMPT:OFN_FILEMUSTEXIST;
j=(write?GetSaveFileName(&ofn):GetOpenFileName(&ofn))?1:0; return j;}
/*-----*/
void SetTitle(HWND wn,char*S){SendMessage(wn,WM_SETTEXT,0,(long)S);}
/*-----*/
void GetTitle(HWND wn,char*S,long n){SendMessage(wn,WM_GETTEXT,n,(long)S);}
/*-----*/
char filterall[]="all files\000*.*\000\000";
char filterOBJ[]="OBJ mesh geometry files\000*.OBJ\000\000";
char filterCR2[]="Poser CR2 files\000*.CR2\000\000";
char filterMKM[]="MKM files\000*.MKM\000\000";
typedef struct{char name[64]; byte green,blue,red; double rad;} element;
element elements[128]; int nelements=0; double bondradius=0; byte bondred=128,bondblue=128,bondgreen=128,readxyz=0;
class atom;
class atom{public: atom*parent; char name[32],shortname[16]; element*sort; double theta,phi,bondl; xyz p;
//double operator-(atom&a);
};
//double atom::operator-(atom&a){return (p-a.p).r();};
atom atoms[1024]; int natoms=0; double pi;
/*-----*/
void DragAccept(HWND wn){DragAcceptFiles(wn,1);}
void DragReject(HWND wn){DragAcceptFiles(wn,0);}
//UINT DragQueryFile(HDROP hdrop,UINT i,char*filename,UNIT fnsize); // returns filename size
short Draghowmanyfiles(HDROP hdrop) {return DragQueryFile(hdrop,-1,0,0);}
//BOOL DragQueryPoint(HDROP hdrop,POINT*lppt); // mouse posn at drop, = nonzero if in client area
//void DragFinish(HDROP hdrop);
/*-----*/
char*parsed[64]; int nargs;
int parse(char*line){int i=0,j,k=0; parsed[0]=0; j=strlen(line); if(j) if(line[j-1]=='\n') line[j-1]=0;
LOOP: while(j=(int(line[k])&0xff),!j?0:j<33?1: j==9/*'\t'*/) line[k++]=0;
if(i>=63?1:!j) goto EXIT; parsed[i++]=line+k;
while(j=line[k],j==' '?0:j=='\t'?0:j) k++; goto LOOP;
EXIT: parsed[i]=0; return i;}
/*-----*/
int argfound(char*s,int k){int i,j; char*t;
for(i=k;t=parsed[i],t;i++) if(!strcmp(s,t)) {for(j=i;j<nargs;j++) parsed[j]=parsed[j+1]; nargs--; return 1;}
return 0;}
/*-----*/
int isgoodname(char*name){int i,j; for(i=0;j=name[i],j;i++) if(!isalnum(j)) if(j!='_') return 0; return 1;}
/*-----*/
void findangles(int n=0){int i,j; atom*at=FM(atom,natoms); xyz a,b; double w;
if(!n) {atoms[0].theta=atoms[0].phi=0; atoms[0].bondl=0;}
for(j=0;j<natoms;j++) at[j].p=atoms[j].p;
for(i=n+1;i<natoms;i++) if(atoms[i].parent==&atoms[n]) {
	 if(!n) {for(j=1;j<natoms;j++) atoms[j].p-=atoms[0].p; atoms[0].p=xyz(0,0,0);} // put root atom on the origin
	 a=atoms[i].p; b=atoms[n].p; w=atan2(a.x-b.x,a.z-b.z); atoms[i].phi=w*180/pi; // find phi
	 for(j=0;j<natoms;j++) atoms[j].p=atoms[j].p.byphi(-w); // back-rotate for phi
	 a=atoms[i].p; b=atoms[n].p; w=atan2(a.z-b.z,a.y-b.y); atoms[i].theta=w*180/pi; // find theta
	 for(j=0;j<natoms;j++) atoms[j].p=atoms[j].p.bytheta(-w); // back-rotate for theta
	 w=atoms[i].bondl=atoms[i].p.y; // find bond length
	 for(j=0;j<natoms;j++) atoms[j].p.y-=w; // slide along bond
	 findangles(i); // recurse
	 for(j=0;j<natoms;j++) atoms[j].p=at[j].p;} // restore coordinates after recursion
free(at);}
/*-----*/
int readMKM(char*mkm,HWND wn){int i,j,k,s=1,level,branchstart,branchend; double w;
char Line[512],line[256],objfile[256],cr2file[256],Name[256],*a;
char*baddir="this folder does not exist and I can't create it";
char*badchar="names must only contain letters and numbers and '_'";
atom*treepath[1024],at; xyz p;
FILE*CR2=0,*OBJ=0,*MKM=fopen(mkm,"r"); if(!MKM) {MessageBox(0,mkm,"I can't open this file",OUCH); s=0; goto WHOA;}

strcpy(line,rootdir); strcat(line,"\\makemol.ini");
GetPrivateProfileString("poserinfo","poseraddr","",posername,256,line);
strcpy(Line,*posername?posername:"c:"); strcat(line,"\\*.*"); *posername=0;
i=GetFileName(wn,posername,Line,"find any file in your Poser installation's root folder",filterall,0);
if(!i) {MessageBox(wn,"I need this information to be able to run.","Exiting",OUCH); s=0; goto WHOA;}
for(i=strlen(posername)-1;i>=0;i--) if(posername[i]=='\\') break;
if(!i) {MessageBox(wn,posername,"This is not a valid file name. Exiting",OUCH); s=0; goto WHOA;}
posername[i]=0; MessageBox(0,posername,"You say that your Poser installation is at",MB_OK);
WritePrivateProfileString("poserinfo","poseraddr",posername,line);

strcpy(Line,posername); cr2file[0]=0;
strcat(Line,"\\Runtime");   if(chdir(Line)) if(mkdir(Line)) {MessageBox(0,Line,baddir,OUCH); s=0; goto WHOA;}
strcat(Line,"\\Libraries"); if(chdir(Line)) if(mkdir(Line)) {MessageBox(0,Line,baddir,OUCH); s=0; goto WHOA;}
strcat(Line,"\\character"); if(chdir(Line)) if(mkdir(Line)) {MessageBox(0,Line,baddir,OUCH); s=0; goto WHOA;}
strcat(Line,"\\Molecules"); if(chdir(Line)) if(mkdir(Line)) {MessageBox(0,Line,baddir,OUCH); s=0; goto WHOA;}
if(!GetFileName(wn,cr2file,Line,"file to write Poser CR2 file to?",filterCR2,1)) {s=0; goto WHOA;}
i=strlen(cr2file); if(stricmp(cr2file+i-4,".cr2")) strcpy(cr2file+i,".cr2");
CR2=fopen(cr2file,"w"); if(!CR2) {MessageBox(0,cr2file,"I can't open this file",OUCH); s=0; goto WHOA;}

strcpy(Line,posername); objfile[0]=0;
strcat(Line,"\\makemol"); if(chdir(Line)) if(mkdir(Line)) {MessageBox(0,Line,baddir,OUCH); s=0; goto WHOA;}
if(!GetFileName(wn,objfile,Line,"file to write object geometry to?",filterOBJ,1)) {s=0; goto WHOA;}
i=strlen(objfile); if(stricmp(objfile+i-4,".obj")) strcpy(objfile+i,".obj");
OBJ=fopen(objfile,"w"); if(!OBJ) {MessageBox(0,objfile,"I can't open this file",OUCH); s=0; goto WHOA;}
strcpy(Name,"molecule"); level=0; treepath[0]=0;

LOOP:
fgets(line,255,MKM); if(feof(MKM)) {/*MessageBox(0,"eol","MKM",OUCH);*/ goto WHOA;}
line[255]=0; strcpy(Line,line); nargs=parse(line); if(!nargs) goto LOOP;
{static char LINE[1024]; LINE[0]=0; for(i=0;parsed[i];i++) sprintf(LINE+strlen(LINE),"{%s} ",parsed[i]);}
/*MessageBox(0,LINE,"line read",OUCH);*/
for(i=0;a=parsed[i],a;i++) if(a[0]=='/') if(a[1]=='/') break;
if(a) {nargs=i; while(parsed[i]) parsed[i++]=0;} // comment found

branchstart=strcmp(parsed[0],"{")?0:1; if(branchstart) {for(i=0;i<nargs;i++) parsed[i]=parsed[i+1]; nargs--;}
branchend=0; while(nargs<=0?0:!strcmp(parsed[nargs-1],"}")) {parsed[--nargs]=0; branchend++;}
if(!natoms) branchstart=0;

if(!stricmp(parsed[0],"name")) {
	 if(nargs<2) {MessageBox(0,Line,"too few arguments in this line",OUCH); s=0; goto WHOA;}
	 strcpy(Name,parsed[1]);
	 if(!isgoodname(Name)) {MessageBox(0,Name,badchar,OUCH); s=0; goto WHOA;}
	 goto LOOP;}

if(!stricmp(parsed[0],"readxyz")) if(!natoms) {readxyz=1; goto LOOP;}

if(!stricmp(parsed[0],"bondradius")) {
	 if(nargs<2) {MessageBox(0,Line,"too few arguments in this line",OUCH); s=0; goto WHOA;}
	 bondradius=fabs(atof(parsed[1]));
	 bondblue =nargs>2?atof(parsed[2]):128;
	 bondgreen=nargs>3?atoi(parsed[3]):128;
	 bondred  =nargs>4?atoi(parsed[4]):128;
	 goto LOOP;}

if(!stricmp(parsed[0],"element")) {element&elem=elements[nelements];;
	 if(nelements>=128) {MessageBox(0,Line,"too many elements",OUCH); s=0; goto WHOA;}
	 if(nargs<6) {MessageBox(0,Line,"too few arguments in this line",OUCH); s=0; goto WHOA;}
	 strcpy(elements[nelements].name,parsed[1]);
	 elem.blue =atoi(parsed[2]);
	 elem.green=atoi(parsed[3]);
	 elem.red  =atoi(parsed[4]);
	 elem.rad  =atof(parsed[5]);
	 if(!isgoodname(elem.name)) {MessageBox(0,parsed[1],badchar,OUCH); s=0; goto WHOA;}
	 for(i=0;i<nelements;i++) if(!stricmp(elem.name,elements[i].name)) {
		  MessageBox(0,elem.name,"element name declared twice",OUCH); s=0; goto WHOA;}
	 nelements++; goto LOOP;}
/*name HOOH
element H 222 3 3 1
element O 3 222 3 1.4
atom H1 H 60 180 2
atom O1 O 60 180 2
atom O2 O 60 180 2
atom H2 H 60 180 2 */

if(!stricmp(parsed[0],"atom")) {atom&at=atoms[natoms];
	 if(natoms>=1024) {MessageBox(0,Line,"too many atoms",OUCH); s=0; goto WHOA;}
	 if(nargs<6) {MessageBox(0,Line,"too few arguments in this line",OUCH); s=0; goto WHOA;}
//char L[512]; sprintf(L,"atom name=%s elem=%s theta=%s phi=%s bondl=%s",parsed[1],parsed[2],parsed[3],parsed[4],parsed[5]);
//MessageBox(0,L,"atom read",OUCH);
	 strcpy(at.name,parsed[1]);
	 if(readxyz) {at.p.x=atof(parsed[3]); at.p.y=atof(parsed[4]); at.p.z=atof(parsed[5]);
		  at.theta=at.phi=0; at.bondl=1;}
	 else {at.theta=atof(parsed[3]); at.phi=atof(parsed[4]); at.bondl=atof(parsed[5]);}
	 sprintf(at.shortname,"atom%d",natoms);
	 if(!isgoodname(at.name)) {MessageBox(0,parsed[2],badchar,OUCH); s=0; goto WHOA;}
	 for(i=0;i<natoms;i++) if(!stricmp(at.name,atoms[i].name)) {char N[256];
		  for(j=2;j<256;j++) {sprintf(N,"%s_%d",at.name,j);
				for(k=0;k<natoms;k++) if(!stricmp(N,atoms[k].name)) goto NN;
				N[31]=0; strcpy(at.name,N); goto NNN;
NN:         ;}}
NNN: for(i=nelements-1;i>=0;i--) if(!strcmp(elements[i].name,parsed[2])) break;
	 if(i<0) {MessageBox(0,parsed[2],"you did not declare this element",OUCH); s=0; goto WHOA;}
	 atoms[natoms].sort=elements+i;
	 at.parent=treepath[level];
	 level+=branchstart;
	 treepath[level]=&at;
	 level=level>branchend?level-branchend:0;
	 natoms++;
	 goto LOOP;}

MessageBox(0,parsed[0],"unidentified instruction",OUCH); goto LOOP;
WHOA: if(!s) goto WHOA2;

if(readxyz) findangles(0);

if(bondradius) {fputs(BONDVERTS,OBJ);
	 for(i=1;i<nelements;i++) fprintf(OBJ,"g %s\nusemtl bonds\n%s",elements[i].name,BONDFACES);}

for(i=0;i<nelements;i++) {w=elements[i].rad;
	 fprintf(OBJ,"g %s\nusemtl %s\n",elements[i].name,elements[i].name);
	 if(w) for(j=0;j<114;j++) fprintf(OBJ,"v %g %g %g\n",BALLVERTS[j][0]*w,BALLVERTS[j][1]*w,BALLVERTS[j][2]*w);
	 fprintf(OBJ,"%s",BALLFACES);}
strcpy(Line,objfile); for(i=0;j=Line[i],j;i++) if(j=='\\') Line[i]=':'; // Poser needs this filename to be in Mac mode!
fprintf(CR2,"{\n\nversion\n\t{\n\tnumber 4.01\n\t}\nfigureResFile %s\nactor BODY:1\n\t{\n\n\t}\n",Line+strlen(posername));
for(i=0;i<natoms;i++) fprintf(CR2,"actor atom%d:1\n\t{\n\tstorageOffset 0 0 0\n\tgeomHandlerGeom 13 %s\n\t}\n",
  i,atoms[i].sort->name);
fprintf(CR2,"figureResFile %s\n\n",Line+strlen(posername));
at=atoms[0]; p=readxyz?at.p:xyz(0,0,0);
fprintf(CR2,ACTORBODY,.01,.01); /* .01 = scale */
fprintf(CR2,ACTORROOT,at.shortname,at.name,at.sort->rad,at.sort->rad,p.x,p.x,p.y,p.y,p.z,p.z);

for(i=1;i<natoms;i++) {atom&at=atoms[i];
	 fprintf(CR2,ACTORATOM1,
		at.shortname,at.name, // names
		at.parent->shortname); // parent
	 if(bondradius) fprintf(CR2,ACTORATOM2,
		at.bondl,at.bondl, // bond_longer morph
		bondradius,bondradius); // bond_thicker morph
	 fprintf(CR2,ACTORATOM3,
		at.bondl,at.bondl, // yOffset
		at.theta,at.theta, // xrot
		at.phi,at.phi, // xrot
		-at.bondl,-at.bondl, // yOffsetB
		at.bondl,at.bondl,  // yTran for bond length
		at.bondl,-at.bondl);} // y's of center & endpoint

fprintf(CR2,"figure \n\t{\n\tname    %s\n\troot    BODY:1\n",Name);
for(i=0;i<natoms;i++) fprintf(CR2,"\taddChild    %s:1 \n\t\t\t %s:1\n",
  atoms[i].shortname,atoms[i].parent?atoms[i].parent->shortname:"BODY");
fprintf(CR2,"\tdefaultPick %s:1 \n\tdisplayOn 1 \n",atoms[0].shortname);
for(i=0;i<natoms;i++) fprintf(CR2,"\tweld    %s:1 \n\t\t\t %s:1\n",
  atoms[i].shortname,atoms[i].parent?atoms[i].parent->shortname:"BODY");
fprintf(CR2, "\tallowsBending 1 \n\tfigureType 1318 \n\torigFigureType 1318 \n\tcanonType 8 \n\tconforming 0\n");
fprintf(CR2,MATERIAL,"Preview",.9,0.,0.);
for(i=0;i<nelements;i++) fprintf(CR2,MATERIAL,elements[i].name,
  elements[i].red/256.,elements[i].green/256.,elements[i].blue/256.);
if(bondradius) fprintf(CR2,MATERIAL,"bonds",bondred/256.,bondgreen/256.,bondblue/256.);
fprintf(CR2,"\tdisplayMode USEPARENT\n\tlocked 0\n\t}\n\tsetGeomHandlerOffset 0 0 0\n}\n");

WHOA2: if(MKM) fclose(MKM); if(CR2) fclose(CR2); if(OBJ) fclose(OBJ);
if(s) {sprintf(Line,"%s\n%s",objfile,cr2file);
	 MessageBox(0,Line,"I have written to the .OBJ file and the .CR2 file",MB_OK);} return s;};
/*-----*/
LRESULT far pascal MainWinProc(HWND wn,UINT iMessage,WPARAM S,LPARAM L){PAINTSTRUCT PS;
WPARAM T; RECT R; long i,l; //HDC dc;
switch(iMessage) {
REP: InvalidateRect(wn,0,1);
default: DEF: return DefWindowProc(wn,iMessage,S,L);
case WM_ENTERIDLE: return 0;
case WM_CREATE: for(i=0;i<256;i++) KEYS[i]=0;
	 SetMenu(wn,mainmenu=LoadMenu(Instance,progname)); ShowWindow(wn,SW_SHOW/*MAXIMIZED*/);
	 DragAcceptFiles(wn,1); goto DEF;
case WM_CLOSE: if(fileopen) {
	 MessageBeep(-1); SetTitle(wn,"Whoa there, I got a file open!!"); return 0;} goto DEF;
case WM_QUIT: goto DEF;
case WM_DESTROY: PostQuitMessage(0); return 0;
case WM_GETMINMAXINFO: {MINMAXINFO*p=(MINMAXINFO*)L;
	 p->ptMaxPosition.x=p->ptMaxPosition.y=-4; return 0;}
case WM_PAINT: {
	 GetClientRect(wn,&R); BeginPaint(wn,&PS); /* dc=GetDC(wn); GetClientRect(wn,&R);
	 Rb=R.bottom-1; HPEN br0=SelectObject(dc,GetStockObject(BLACK_PEN));
	 if(OB->nf) if(OB->fac) {dc=PS.hdc; double xmin=1e50,ymin=1e50,xmax=-1e50,ymax=-1e50;
		  forallfaces(OB) forvert() {
			 xmax=max(xmax,V->p->a.x); xmin=min(xmin,V->p->a.x);
			 ymax=max(ymax,V->p->a.y); ymin=min(ymin,V->p->a.y);}
		  if(xmax==xmin) {xmax=1; xmin=0;} if(ymax==ymin) {ymax=1; ymin=0;}
		  xb=-xmin; yb=-ymin; xs=(R.right-2)/(xmax-xmin); ys=(R.bottom-2)/(ymax-ymin);
		  xs=ys=min(xs,ys);
		  forallfaces(OB) forvert() {U=V==I?I+F->n-1:V-1; Line(dc,V->p->a,U->p->a);}}
	 SelectObject(dc,br0); */ EndPaint(wn,&PS);
	 if(Argc>1) {Argc=0; strcpy(file,_argv[1]); goto AUTOREAD;} goto DEF;}

#if 0
case WM_KEYDOWN: case WM_SYSKEYDOWN: case WM_KEYUP: case WM_SYSKEYUP: {
	 byte W=(byte)(S&0xff); double w,deg=atan(1)/45,c,s;
	 int rep=(short)(L&0xffff),/* scan=(short)((L>>16)&0xff),*/ /*ext=(short)((L>>24)&1),*/
	 /*alt=(short)((L>>29)&1),*/ up=iMessage&1, rel=(short)((L>>31)&1); //uns long G;
	 KEYS[W]=rel?0:0xff;// G=0;// if(S!=VK_BACK) j=ToAscii(S,scan,KEYS,&G,1); i=(byte)(G&0xff);
//    if(i) if(!up) goto CHAR;
//	 c=cos(10*rep*deg); s=sin(10*rep*deg);
//	 if(!up) switch(W) {default: goto DEF;
//	 case VK_HOME:   s=-s; case VK_END:    for(i=0;i<OB->np;i++) {
//		  xyz&G=OB->point[i].a; w=c*G.y-s*G.z; G.z=s*G.y+c*G.z; G.y=w;} goto R;
//	 case VK_PRIOR:  s=-s; case VK_NEXT:   for(i=0;i<OB->np;i++) {
//		  xyz&G=OB->point[i].a; w=c*G.z-s*G.x; G.x=s*G.z+c*G.x; G.z=w;} goto R;
//	 case VK_INSERT: s=-s; case VK_DELETE: for(i=0;i<OB->np;i++) {
//		  xyz&G=OB->point[i].a; w=c*G.x-s*G.y; G.y=s*G.x+c*G.y; G.x=w;} goto R;
//	 R: InvalidateRect(wn,0,1); goto REP;}
	 }
#endif

case WM_DROPFILES: i=Draghowmanyfiles(HDROP(S));
		 if(i!=1) {MessageBox(wn,"one file at a time please","drag-and-drop",OUCH); goto DRAGOUT;}
	 DragQueryFile(HDROP(S),0,file,256); strcpy(tit,file); DragFinish(HDROP(S)); goto AUTOREAD;
DRAGOUT: DragFinish(HDROP(S)); break;

case WM_COMMAND: T=S; goto MENU;}
MENU: switch((unsigned short)T) {default: goto DEF;

case _READFILE_: if(!GetFileName(wn,file,0,"file to read molecule data from?",filterMKM,0)) goto DEF;
READING: AUTOREAD: {char T[512];
	 l=strlen(file); fileopen=1;
	 if(stricmp(file+l-4,".mkm")) {fileopen=0; MessageBox(wn,file,"bad suffix",OUCH); goto ZINIT;}
	 if(readMKM(file,wn)) goto RDOK;
	 MessageBox(wn,file,"I tried to read this file but it didn't work",OUCH);
	 fileopen=0; goto ZINIT;
	 RDOK: fileopen=0;
	 strcpy(T,"makemol: "); strcpy(T+9,file); SetTitle(wn,T);
	 ZINIT: strcpy(tit,file); goto REP;}
case _HELP_: MessageBox(0,"For information, read the file makemol_readme.txt that came with this application.","",MB_OK);
/* MessageBox(0,"HOME and END around the x-axis,\n\
PAGEUP and PAGEDOWN around the y-axis,\n\
INSERT and DELETE around the z-axis.","These keys rotate the image by 10 each way:-",MB_OK); */
goto DEF;

case _EXIT_: EXIT2: SendMessage(wn,WM_CLOSE,0,0); goto DEF;
}}
/*-----*/
static void Register(char*name,WNDPROC proc) {WNDCLASS c;
c.style=CS_HREDRAW|CS_VREDRAW|CS_SAVEBITS; c.lpfnWndProc=proc; c.cbClsExtra=0;
c.cbWndExtra=2; c.hInstance=Instance; c.hIcon=LoadIcon(Instance,progname);
c.hCursor=LoadCursor(0,IDC_ARROW); c.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
c.lpszMenuName=0; c.lpszClassName=name; if(!RegisterClass(&c)) exit(0);}
/*-----*/
HWND newwindow(char*clas,char*name,long c=0){
HWND w=CreateWindow(clas,name,WS_OVERLAPPEDWINDOW|c,
	 CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,Instance,0);
	 if(w) {ShowWindow(w,SW_SHOW); UpdateWindow(w);} return w;}
/*-----*/
// Turn off warning: Parameter 'CmdLine' is never used in function WinMain(unsigned int,unsigned int,char far*,int)
#pragma argsused
// Turn off warning: 'MainWnd' is assigned a value that is never used in function WinMain(unsigned int,unsigned int,char far*,int)
#pragma option -w-aus
/*-----*/
int PASCAL WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int nCmdShow){
MSG msg; Instance=hInst; PrevInstance=hPrev; CmdShow=(short)nCmdShow;
if(!hPrev) Register(progname,MainWinProc);
manipulate(".pz3"); strcpy(posername,strang);
mwn=newwindow(progname,progname,/*WS_HSCROLL|WS_VSCROLL|*/WS_MAXIMIZE); if(!mwn) exit(0);
posername[0]=0; pi=4*atan(1.); GetCurrentDirectory(256,rootdir);
while(GetMessage(&msg,0,0,0)) {TranslateMessage(&msg); DispatchMessage(&msg);}
return msg.wParam;}

